/*
 * Dinge die definiert werden mssen:
 *  
 *  baseValues: Namen
 *  
 *  coldef: Spalten fr die Gridansicht und Editmodus { 
 *  	renderfkt : null fr standard-renderer, ansonsten eigene FKT : Optional, nur Grid 
 *  	name : ID der Spalte,    
 *  	title : berschrift, 
 *  	description: Beschreibung des Wertes  : Tooltip
 *  	type : folgende Typen:
 *  		* string/null: String
 *          * integer: Zahl
 *          * trigger: 
 *          * action: 
 *          * message: Nachricht (Email)
 *  }
 *  
 * */

//https://10.0.35.100/json/property/query?query=/apartment/zones/*(ZoneID,isPresent,name)/groups/*(name,group)/scenes/*(scene,name)

var baseValues = {
	appId : 'event-mailer',
	editorTitle : 'Nachrichteigenschaft',
	newEntry : 'Neue Nachricht',
	editEntry : 'Nachricht bearbeiten',
	disableEntry : 'Benachrichtung abschalten',
	enableEntry : 'Benachrichtung anschalten',
	deleteEntry : 'Benachrichtigung l&ouml;schen',
	helpText :'<h2>Allgemeines</h2>'+
		'<p>Diese digitalSTROM Applikation dient zum Einstellen von Benachrichtungen, die automatisch ausgel&ouml;st werden, sobald im Haus eine entsprechende digitalSTROM Aktivit&auml;t ausgef&uuml;hrt wird.</p>'+
		'<p>Man kann somit E-Mails verschicken lassen, wenn jemand an der T&uuml;r klingelt oder Panik aktiviert. Wenn man in Urlaub geht, kann man sich Benachrichtigungen einstellen, die sofort eine Email verschicken wenn z.B. im Flur das Licht eingeschaltet wird.</p>'+
		'<p>In dieser Version k&ouml;nnen nur E-Mails verschicken werden, weitere Benachrichtigungsarten (SMS etc.) werden in sp&auml;teren Varianten zur Verf&uuml;gung gestellt werden.'+
		'<h2>Voraussetzungen</h2>'+
		'<p>Der dSS verschickt selbstst&auml;ndig E-Mails, welche von dieser Applikation ausgel&ouml;st wird. Als Voraussetzung muss daher eine Email-Konfiguration zentral im Konfigurator hinterlegt sein, welche zum Absenden verwendet werden.</p>'+
		'<p>Um sicher zu stellen, dass Benachrichtigungen verschickt werden k&ouml;nnen, f&uuml;hren Sie folgende Schritte bitte aus:'+
		'<ol style="padding: 20px;">'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Im digitalSTROM Konfigurator auf <b>Erweiterte Ansicht</b> wechseln</li>'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Auf <b>SW: System</b> wechseln</li>'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Auf <b>E-Mail Einstellungen</b> im Men&uuml; wechseln</li>'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Dort die Eingabefelder auf Korrektheit pr&uuml;fen</li>'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Auf <b>Test E-Mail versenden</b> klicken</li>'+
		'<li style="list-style: decimal inside none;color:#005138;padding-bottom: 4px;">Ihr Postfach pr&uuml;fen und sicherstellen, dass die Test E-Mail auch angekommen ist.</li>'+
		'</ol></p>'+
		'<p>Hinweise:'+
		'	<ul style="padding: 20px;">'+
		'		<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Es wird empfohlen, f&uuml;r Ihre Installation ein separates E-Mail Konto zu erstellen, welches sie auf dem dSS verwenden k&ouml;nnen. Dazu k&ouml;nnen sie einen der zahlreichen Gratis-Provider wie z.B. <a href="http://mail.google.com" target="_blank">Google Mail</a> verwenden</li>'+
		'		<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Bitte beachten Sie, dass E-Mails, die vom dSS versendet worden, von Ihrem E-Mail Provider oder E-Mail Programm als Spam eingestuft werden k&ouml;nnten, da sie automatisch erstellt worden ist.</li>'+
		'	</ul>'+
		'</p>'+
		'<h2>&Uuml;bersicht &uuml;ber alle Benachrichtigungen</h2>'+
		'<p>In dieser Ansicht werden alle vorhandenen Benachrichtigungen aufgelistet. Es wird aufgelistet, welche Aktivit&auml;ten welche Benachrichtungen ausl&ouml;sen. Ausser den Befehlen zum Bearbeiten der Benachrichtigungen kann man hier auch einzelne ein- und ausschalten, ohne die Benachrichtigung komplett aus dem System zu l&ouml;schen.' + 
	    '</p>'+		
		'<h2>Benachrichtigungen erstellen oder bearbeiten</h2>'+
		'<p>'+
		'In diesen Fenster kann eine Benachrichtigung eingestellt werden. '+
		'Es gibt drei Bereiche:'+
		'<ul style="padding: 20px;">'+
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;"><b>Name</b><br>Der Name dient als Bezeichner f&uuml;r einen Benachrichtungseintrag. Er hat dar&uuml;ber hinaus keine weitere technische Bedeutung.</li>'+
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;"><b>Ausl&ouml;sende Aktivit&auml;t*</b><br>Hier wird die Aktivit&auml;t ausgew&auml;hlt, die eine Benachrichtigung ausl&ouml;st. Dabei muss zuerst der Raum, danach die Gruppe und schlie&szlig;lich die Aktivit&auml;t ausgew&auml;hlt werden.'+ 
		'Zur Auswahl stehen alle Raum/Gruppe/Aktivit&auml;tskombinationen, welche durch die installierten digitalSTROM Ger&auml;te erreichbar sind. '+
		'Um dar&uuml;ber hinaus auf Aktivit&auml;ten reagieren zu k&ouml;nnen, die per Apps wie der <i>scene-responder</i>, IP-Ger&auml;te oder Weboberfl&auml;chen wie die <i>mobile-remote-control</i>-App ausgel&ouml;st werden, kann durch das Eingabefeld <b>alle Gruppen/Aktivit&auml;ten anzeigen</b> die Vorfilterung der Auswahlm&ouml;glichkeiten aufgehoben werden.</li>'+
		'<li style="list-style: disc inside none;c	olor:#005138;padding-bottom: 4px;"><b>Nachricht</b><br>Hier wird die Nachricht eingegeben, welche bei Aufruf der Aktivit&auml;t versendet wird. <br>Bei <b>Empf&auml;nger</b> ist eine Emailadresse, muss daher vom typischen E-Mailformat sein. (Bsp. <i>news@digitalstrom.org</i>)'+ 
		'<br><b>Betreff</b> ist der Betreff der versendeten Email.<br><b>Inhalt</b> der Inhalt der Nachricht. Die versendete E-Mail ist eine einfache Textnachricht, daher sind keine Formatierungen aktuell m&ouml;glich.</li>'+
		'</ul>'+
		'</p>'+
		'<p>* Hinweise:'+ 
		'<ul style="padding-left: 20px;">'+
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Der Raum <b>Ganze Installation</b> bedeutet, dass das Ziel einer Aktivit&auml;t immer die ganze Installation sein muss, d.h. alle R&auml;ume gleichzeitig. Es bedeutet nicht, da&szlig; die Eigenschaft <b>Raum</b> f&uuml;r diese Benachrichtigung nicht ausgewertet wird.</li>'+ 
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Die Gruppe <img src="'+getImagePathForGroup(0,0)+'"><b>Alle</b> bedeutet, dass das Ziel einer Aktivit&auml;t alle Gruppen gleichzeitig ist. Es bedeutet nicht, da&szlig; die Eigenschaft <b>Gruppe</b> f&uuml;r diese Benachrichtigung nicht ausgewertet wird.</li>'+
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">F&uuml;r die Standardaktivt&auml;ten '+getImageForScene(0,0,73)+'<i>Klingeln</i>, '+getImageForScene(0,0,65)+'<i>Panik</i>, '+getImageForScene(0,0,72)+'<i>Gehen</i> und '+getImageForScene(0,0,71)+'<i>Kommen</i> muss der Raum <i>ganze Installation</i> und die Gruppe <img src="'+getImagePathForGroup(0,0)+'"><i>Alle</i> gew&auml;hlt werden.</li>'+
		'<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">F&uuml;r die Standardaktivt&auml;ten '+getImageForScene(0,0,67)+'<i>Standby</i> und '+getImageForScene(0,0,68)+'<i>Deepoff</i> muss der entsprechende Raum und die Gruppe <img src="'+getImagePathForGroup(0,0)+'"><i>Alle</i> in diesen Raum gew&auml;hlt werden.</li>'+
		'</ul>'+
		'</p>'
};

function initValues() {
	login();
	initCaches();
}

function checkMinimalVersion()
{
	var sVersion=getPropertyString('/system/version/version');
	var oArray=sVersion.split(".");
	var iVersion_main=parseInt(oArray[0],10);
	var iVersion_min=parseInt(oArray[1],10);
	
	var minimalVersion=true;
	if (iVersion_main<1)
		minimalVersion=false;
	if (iVersion_main==1)
	{
		if (iVersion_min<2)
			minimalVersion=false;
	}
	if (minimalVersion==false)
	{	
		return 'Diese App ben&ouml;tigt minimal die dSS-Version <b>1.2.0</b><br>' +
		       'Bitte f&uuml;hren Sie das kostenlose Systemupdate durch.<br>'+
		       'Dies kann im Konfigurator in der erweiterten Ansicht unter <b>System</b> -&gt; <b>System Update</b> gestartet werden.';
	}
	return true;
	
}

function loadValueFunction() {
	// '/scripts/event-mailer/values/*(name,id,disabled)/*(zone,group,scene,messageType,receiver,subject,message)'
	var sString = ajaxSyncRequest(
			'/json/property/query',
			{
				'query' : '/scripts/event-mailer/values/*(name,id,disabled)/*(zone,group,scene,messageType,receiver,subject,message)'
			});
	var oServerObject = eval('(' + sString + ')');
	var oArray = [];
	for ( var iIndex = 0; iIndex < oServerObject.result.values.length; iIndex++) {
		var oSubObject = oServerObject.result.values[iIndex];
		var oObject = {};
		if (oSubObject.id != null)
			oObject.id = oSubObject.id;
		if (oSubObject.name != null)
			oObject.name = oSubObject.name;
		if (oSubObject.disabled != null)
			oObject.disabled = oSubObject.disabled;
		if (oSubObject[oSubObject.id] != null) {
			var oSubArray = oSubObject[oSubObject.id];
			for ( var jIndex = 0; jIndex < oSubArray.length; jIndex++) {
				var oSubSubObject = oSubArray[jIndex];
				if (oSubSubObject.messageType != null) {
					oObject.message = {};
					oObject.message.messageType = oSubSubObject.messageType;
					oObject.message.receiver = oSubSubObject.receiver;
					oObject.message.subject = oSubSubObject.subject;
					oObject.message.message = oSubSubObject.message;
				}
				if (oSubSubObject.zone != null) {
					oObject.trigger = {};
					oObject.trigger.zone = oSubSubObject.zone;
					oObject.trigger.group = oSubSubObject.group;
					oObject.trigger.scene = oSubSubObject.scene;
				}
			}
		}
		oArray.push(oObject);
	}
	fillAppDataStore(oArray);
}

function saveValueFunction(oValue) {
	var oPropsArray = [
			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/id',
				value : oValue.id,
				message : 'Speichere Daten'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/name',
				value : oValue.name,
				message : '"Namen" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/disabled',
				value : oValue.disabled,
				message : '"Aktiv" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/messageType',
				value : oValue.message.messageType,
				message : '"Nachrichtentyp" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/receiver',
				value : oValue.message.receiver,
				message : '"Empf&auml;nger" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/subject',
				value : oValue.message.subject,
				message : '"Betreff" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/message',
				value : oValue.message.message,
				message : '"Nachricht" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/zone',
				value : oValue.trigger.zone,
				message : '"Raum" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/group',
				value : oValue.trigger.group,
				message : '"Gruppe" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/scene',
				value : oValue.trigger.scene,
				message : '"Aktivit&auml;t" speichern'
			}
	];
	var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };

	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
}

function deleteValueFunction(oValue) {
	removePropertySync('/scripts/' + baseValues.appId + '/values/' + oValue.id);
	raiseEvent(baseValues.appId,{'actions' : 'save'});
	
	loadValueFunction();
}

Ext.onReady(function() {
	initValues();
	initAppDataStore([ 'name', 'email', 'phone', 'id' ]);

	var colDef = [ {
		type : 'string',
		name : "name",
		title : "Name"
	}, {
		type : 'trigger',
		name : "trigger",
		title : "Ausl&ouml;ser"
	}, {
		type : 'message',
		name : "message",
		title : "Nachricht"
	} ];
	makeBasePanel(colDef, saveValueFunction, deleteValueFunction,checkMinimalVersion);
	loadValueFunction();
});
